rc revision 64892
1#!/bin/sh
2# $FreeBSD: head/etc/rc 64892 2000-08-21 14:33:20Z sheldonh $
3#	From: @(#)rc	5.27 (Berkeley) 6/5/91
4
5# System startup script run by init on autoboot
6# or after single-user.
7# Output and error are redirected to console by init,
8# and the console is the controlling terminal.
9
10# Note that almost all of the user-configurable behavior is no longer in
11# this file, but rather in /etc/defaults/rc.conf.  Please check that file
12# first before contemplating any changes here.  If you do need to change
13# this file for some reason, we would like to know about it.
14
15stty status '^T'
16
17# Set shell to ignore SIGINT (2), but not children;
18# shell catches SIGQUIT (3) and returns to single user after fsck.
19#
20trap : 2
21trap : 3	# shouldn't be needed
22
23HOME=/
24PATH=/sbin:/bin:/usr/sbin:/usr/bin:/usr/local/sbin
25export HOME PATH
26
27# BOOTP diskless boot.  We have to run the rc file early in order to
28# retarget various config files.
29#
30if [ -r /etc/rc.diskless1 ]; then
31	dlv=`/sbin/sysctl -n vfs.nfs.diskless_valid 2> /dev/null`
32	if [ ${dlv:=0} != 0 ]; then
33		. /etc/rc.diskless1
34	fi
35fi
36
37# If there is a global system configuration file, suck it in.
38#
39if [ -r /etc/defaults/rc.conf ]; then
40	. /etc/defaults/rc.conf
41	source_rc_confs
42elif [ -r /etc/rc.conf ]; then
43	. /etc/rc.conf
44fi
45
46# Configure ccd devices.
47#
48if [ -r /etc/ccd.conf ]; then
49	ccdconfig -C
50fi
51
52case ${start_vinum} in
53[Yy][Ee][Ss])
54	vinum start
55	;;
56esac
57
58swapon -a
59
60case $1 in
61autoboot)
62	echo Automatic boot in progress...
63	fsck -p
64	case $? in
65	0)
66		;;
67	2)
68		exit 1
69		;;
70	4)
71		reboot
72		echo "reboot failed... help!"
73		exit 1
74		;;
75	8)
76		echo "Automatic file system check failed... help!"
77		exit 1
78		;;
79	12)
80		echo "Reboot interrupted"
81		exit 1
82		;;
83	130)
84		# interrupt before catcher installed
85		exit 1
86		;;
87	*)
88		echo "Unknown error in reboot"
89		exit 1
90		;;
91	esac
92	;;
93*)
94	echo Skipping disk checks ...
95	;;
96esac
97
98set -T
99trap "echo 'Reboot interrupted'; exit 1" 3
100
101# root normally must be read/write, but if this is a BOOTP NFS
102# diskless boot it does not have to be.
103#
104case ${root_rw_mount} in
105[Nn][Oo] | '')
106	;;
107*)
108	if ! mount -u -o rw / ; then
109		echo "Mounting root filesystem rw failed, startup aborted"
110		exit 1
111	fi
112	;;
113esac
114
115umount -a >/dev/null 2>&1
116
117# Mount everything except nfs filesystems.
118mount -a -t nonfs
119
120case $? in
1210)
122	;;
123*)
124	echo "Mounting /etc/fstab filesystems failed, startup aborted"
125	exit 1
126	;;
127esac
128
129# Run custom disk mounting function here
130#
131if [ -n "${diskless_mount}" -a -r "${diskless_mount}" ]; then
132		sh ${diskless_mount}
133fi
134
135# Recover some entropy so the rebooting /dev/random can reseed
136#
137case ${entropy_file} in
138[Nn][Oo] | '')
139	;;
140*)
141	if [ -f ${entropy_file} -a -r ${entropy_file} -a -w /dev/random ]; then
142		echo "Reading entropy file"
143		cat ${entropy_file} > /dev/random
144		rm -f ${entropy_file}
145	fi
146	;;
147esac
148
149adjkerntz -i
150
151purgedir() {
152	local dir file
153
154	if [ $# -eq 0 ]; then
155		purgedir .
156	else
157		for dir
158		do
159		(
160			cd "$dir" && for file in .* *
161			do
162				[ ."$file" = .. -o ."$file" = ... ] && continue
163				[ -d "$file" -a ! -L "$file" ] &&
164					purgedir "$file"
165				[ -f "$file" ] && rm -f -- "$file"
166			done
167		)
168		done
169	fi
170}
171
172clean_var() {
173	if [ ! -f /var/run/clean_var ]; then
174		rm -rf /var/run/*
175		purgedir /var/spool/lock
176		rm -rf /var/spool/uucp/.Temp/*
177		# Keep a copy of the boot messages around
178		dmesg >/var/run/dmesg.boot
179		# And an initial utmp file
180		(cd /var/run && cp /dev/null utmp && chmod 644 utmp;)
181		>/var/run/clean_var
182	fi
183}
184
185if [ -d /var/run -a -d /var/spool/lock -a -d /var/spool/uucp/.Temp ]; then
186	# network_pass1() *may* end up writing stuff to /var - we don't want to
187	# remove it immediately afterwards - *nor* to we want to fail to clean
188	# an nfs-mounted /var.
189	clean_var
190fi
191
192# Add additional swapfile, if configured.
193#
194case ${swapfile} in
195[Nn][Oo] | '')
196	;;
197*)
198	if [ -w "${swapfile}" -a -c /dev/vn0b ]; then
199		echo "Adding ${swapfile} as additional swap."
200		vnconfig /dev/vn0b ${swapfile} && swapon /dev/vn0b
201	fi
202	;;
203esac
204
205# Set sysctl variables as early as we can
206#
207if [ -r /etc/rc.sysctl ]; then
208	. /etc/rc.sysctl
209fi
210
211# Configure serial devices
212#
213if [ -r /etc/rc.serial ]; then
214	. /etc/rc.serial
215fi
216
217# Start up PC-card configuration
218#
219if [ -r /etc/rc.pccard ]; then
220	. /etc/rc.pccard
221fi
222
223# Start up the initial network configuration.
224#
225if [ -r /etc/rc.network ]; then
226	. /etc/rc.network	# We only need to do this once.
227	network_pass1
228fi
229
230case ${ipv6_enable} in
231[Yy][Ee][Ss])
232	if [ -r /etc/rc.network6 ]; then
233		. /etc/rc.network6	# We only need to do this once also.
234		network6_pass1
235	fi
236	;;
237esac
238
239# Mount NFS filesystems if present in /etc/fstab
240case "`mount -d -a -t nfs`" in
241*mount_nfs*)
242	echo -n "Mounting NFS file systems"
243	mount -a -t nfs
244	echo .
245	;;
246esac
247
248# Whack the pty perms back into shape.
249#
250chflags 0 /dev/tty[pqrsPQRS]*
251chmod 666 /dev/tty[pqrsPQRS]*
252chown root:wheel /dev/tty[pqrsPQRS]*
253
254# Clean up left-over files
255#
256clean_var			# If it hasn't already been done
257rm /var/run/clean_var
258
259# Clearing /tmp at boot-time seems to have a long tradition.  It doesn't
260# help in any way for long-living systems, and it might accidentally
261# clobber files you would rather like to have preserved after a crash
262# (if not using mfs /tmp anyway).
263#
264# See also the example of another cleanup policy in /etc/periodic/daily.
265#
266case ${clear_tmp_enable} in
267[Yy][Ee][Ss])
268	echo clearing /tmp
269	# prune quickly with one rm, then use find to clean up /tmp/[lq]*
270	# (not needed with mfs /tmp, but doesn't hurt there...)
271	(cd /tmp && rm -rf [a-km-pr-zA-Z]* &&
272		find -d . ! -name . ! -name lost+found ! -name quota.user \
273		! -name quota.group -exec rm -rf -- {} \;)
274	;;
275esac
276
277# Remove X lock files, since they will prevent you from restarting X11
278# after a system crash.
279#
280rm -f /tmp/.X*-lock /tmp/.X11-unix/*
281
282# Snapshot any kernel -c changes back to disk here <someday>.
283# This has changed with ELF and /kernel.config.
284
285echo -n 'additional daemons:'
286
287# Start system logging and name service.  Named needs to start before syslogd
288# if you don't have a /etc/resolv.conf.
289#
290case ${syslogd_enable} in
291[Yy][Ee][Ss])
292	# Transitional symlink (for the next couple of years :) until all
293	# binaries have had a chance to move towards /var/run/log.
294	if [ ! -h /dev/log ]; then
295		# might complain for r/o root f/s
296		ln -sf /var/run/log /dev/log
297	fi
298
299	rm -f /var/run/log
300	echo -n ' syslogd';	syslogd ${syslogd_flags}
301	;;
302esac
303
304echo '.'
305
306# Enable dumpdev so that savecore can see it.
307# /var/crash should be a directory or a symbolic link
308# to the crash directory if core dumps are to be saved.
309#
310case ${dumpdev} in
311[Nn][Oo] | '')
312	;;
313*)
314	if [ -e "${dumpdev}" -a -d /var/crash ]; then
315		dumpon ${dumpdev}
316		echo -n checking for core dump...
317		savecore /var/crash
318	fi
319	;;
320esac
321
322if [ -n "${network_pass1_done}" ]; then
323	network_pass2
324fi
325
326# Enable/Check the quotas (must be after ypbind if using NIS)
327#
328case ${enable_quotas} in
329[Yy][Ee][Ss])
330	case ${check_quotas} in
331	[Yy][Ee][Ss])
332		echo -n 'checking quotas:'
333		quotacheck -a
334		echo ' done.'
335		;;
336	esac
337
338	echo -n 'enabling quotas:'
339	quotaon -a
340	echo ' done.'
341	;;
342esac
343
344if [ -n "${network_pass2_done}" ]; then
345	network_pass3
346fi
347
348# Build ps databases
349#
350dev_mkdb
351
352# Check the password temp/lock file
353#
354if [ -e /etc/ptmp ]; then
355	logger -s -p auth.err \
356	"password file may be incorrect -- /etc/ptmp exists"
357fi
358
359case ${accounting_enable} in
360[Yy][Ee][Ss])
361	if [ -d /var/account ]; then
362		echo 'turning on accounting'
363		if [ ! -e /var/account/acct ]; then
364			touch /var/account/acct
365		fi
366		accton /var/account/acct
367	fi
368	;;
369esac
370
371# Make shared lib searching a little faster.  Leave /usr/lib first if you
372# add your own entries or you may come to grief.
373#
374ldconfig="/sbin/ldconfig"
375case ${ldconfig_insecure} in
376[Yy][Ee][Ss])
377	ldconfig="${ldconfig} -i"
378	;;
379esac
380if [ -x /sbin/ldconfig ]; then
381	case `/usr/bin/objformat` in
382	elf)
383		_LDC=/usr/lib
384		for i in ${ldconfig_paths}; do
385			if [ -d "${i}" ]; then
386				_LDC="${_LDC} ${i}"
387			fi
388		done
389		echo 'setting ELF ldconfig path:' ${_LDC}
390		${ldconfig} -elf ${_LDC}
391		;;
392	esac
393
394	# Legacy aout support for i386 only
395	case `sysctl -n hw.machine` in
396	i386)
397		# Default the a.out ldconfig path.
398		: ${ldconfig_paths_aout=${ldconfig_paths}}
399		_LDC=/usr/lib/aout
400		for i in ${ldconfig_paths_aout}; do
401			if [ -d "${i}" ]; then
402				_LDC="${_LDC} ${i}"
403			fi
404		done
405		echo 'setting a.out ldconfig path:' ${_LDC}
406		${ldconfig} -aout ${_LDC}
407		;;
408	esac
409fi
410
411# Now start up miscellaneous daemons that don't belong anywhere else
412#
413echo -n starting standard daemons:
414case ${inetd_enable} in
415[Nn][Oo])
416	;;
417*)
418	echo -n ' inetd';	inetd ${inetd_flags}
419	;;
420esac
421
422case ${cron_enable} in
423[Nn][Oo])
424	;;
425*)
426	echo -n ' cron';	cron
427	;;
428esac
429
430case ${lpd_enable} in
431[Yy][Ee][Ss])
432	echo -n ' printer';	${lpd_program:-/usr/sbin/lpd} ${lpd_flags}
433	;;
434esac
435
436case ${sendmail_enable} in
437[Yy][Ee][Ss])
438	if [ -r /etc/mail/sendmail.cf ]; then
439		echo -n ' sendmail';	/usr/sbin/sendmail ${sendmail_flags}
440	fi
441	;;
442esac
443
444case ${sshd_enable} in
445[Yy][Ee][Ss])
446	if [ -x ${sshd_program:-/usr/sbin/sshd} ]; then
447		echo -n ' sshd';
448		${sshd_program:-/usr/sbin/sshd} ${sshd_flags}
449	fi
450	;;
451esac
452
453case ${usbd_enable} in
454[Yy][Ee][Ss])
455	echo -n ' usbd';	/usr/sbin/usbd ${usbd_flags}
456	;;
457esac
458
459echo '.'
460
461# Recover vi editor files.
462find /var/tmp/vi.recover ! -type f -a ! -type d -delete
463vibackup=`echo /var/tmp/vi.recover/vi.*`
464if [ "${vibackup}" != '/var/tmp/vi.recover/vi.*' ]; then
465	echo 'Recovering vi editor sessions'
466	for i in /var/tmp/vi.recover/vi.*; do
467		# Only test files that are readable.
468		if [ ! -r "${i}" ]; then
469			continue
470		fi
471
472		# Unmodified nvi editor backup files either have the
473		# execute bit set or are zero length.  Delete them.
474		if [ -x "${i}" -o ! -s "${i}" ]; then
475			rm -f "${i}"
476		fi
477	done
478
479	# It is possible to get incomplete recovery files, if the editor
480	# crashes at the right time.
481	virecovery=`echo /var/tmp/vi.recover/recover.*`
482	if [ "${virecovery}" != "/var/tmp/vi.recover/recover.*" ]; then
483		for i in /var/tmp/vi.recover/recover.*; do
484			# Only test files that are readable.
485			if [ ! -r "${i}" ]; then
486				continue
487			fi
488
489			# Delete any recovery files that are zero length,
490			# corrupted, or that have no corresponding backup file.
491			# Else send mail to the user.
492			recfile=`awk '/^X-vi-recover-path:/{print $2}' < "${i}"`
493			if [ -n "${recfile}" -a -s "${recfile}" ]; then
494				sendmail -t < "${i}"
495			else
496				rm -f "${i}"
497			fi
498		done
499	fi
500fi
501
502# Make a bounds file for msgs(1) if there isn't one already
503# "Delete important files with symlink" security hole?
504#
505if [ -d /var/msgs -a ! -f /var/msgs/bounds ]; then
506	echo 0 > /var/msgs/bounds
507fi
508
509case ${update_motd} in
510[Nn][Oo] | '')
511	;;
512*)
513	if T=`mktemp /tmp/_motd.XXXXXX`; then
514		uname -v | sed -e 's,^\([^#]*\) #\(.* [1-2][0-9][0-9][0-9]\).*/\([^\]*\) $,\1 (\3) #\2,' > ${T}
515		awk '{if (NR == 1) {if ($1 == "FreeBSD") {next} else {print "\n"$0}} else {print}}' < /etc/motd >> ${T}
516		cmp -s ${T} /etc/motd || {
517			cp ${T} /etc/motd
518			chmod 644 /etc/motd
519		}
520		rm -f ${T}
521	fi
522	;;
523esac
524
525# Configure implementation specific stuff
526#
527arch=`uname -m`
528if [ -r /etc/rc.${arch} ]; then
529	. /etc/rc.${arch}
530fi
531
532# Run rc.devfs if readable to customize devfs
533#
534if [ -r /etc/rc.devfs ]; then
535	sh /etc/rc.devfs
536fi
537
538echo -n additional ABI support:
539
540# Start the Linux binary compatibility if requested.
541#
542case ${linux_enable} in
543[Yy][Ee][Ss])
544	echo -n ' linux'
545	if ! kldstat -v | grep -E 'linux(aout|elf)' > /dev/null; then
546		kldload linux > /dev/null 2>&1
547	fi
548	if [ -x /compat/linux/sbin/ldconfig ]; then
549		/compat/linux/sbin/ldconfig
550	fi
551	;;
552esac
553
554# Start the SysVR4 binary emulation if requested.
555#
556case ${svr4_enable} in
557[Yy][Ee][Ss])
558	echo -n ' svr4';	kldload svr4 > /dev/null 2>&1
559	;;
560esac
561
562echo .
563
564# Do traditional (but rather obsolete) rc.local file if it exists.  If you
565# use this file and want to make it programmatic, source /etc/defaults/rc.conf
566# in /etc/rc.local and add your custom variables to /etc/rc.conf, as
567# shown below.  Please do not put local extensions into /etc/rc itself.
568# Use /etc/rc.local
569#
570# ---- rc.local ----
571#	if [ -r /etc/defaults/rc.conf ]; then
572#		. /etc/defaults/rc.conf
573#		source_rc_confs
574#	elif [ -r /etc/rc.conf ]; then
575#		. /etc/rc.conf
576#	fi
577#
578#	... additional startup conditionals ...
579# ---- rc.local ----
580#
581if [ -r /etc/rc.local ]; then
582	echo -n 'starting local daemons:'
583	sh /etc/rc.local
584	echo '.'
585fi
586
587# For each valid dir in $local_startup, search for init scripts matching *.sh
588#
589case ${local_startup} in
590[Nn][Oo] | '')
591	;;
592*)
593	echo -n 'Local package initialization:'
594	for dir in ${local_startup}; do
595		if [ -d "${dir}" ]; then
596			for script in ${dir}/*.sh; do
597				if [ -x "${script}" ]; then
598					(set -T
599					 trap 'exit 1' 2
600					 ${script} start)
601				fi
602			done
603		fi
604	done
605	echo .
606	;;
607esac
608
609if [ -n "${network_pass3_done}" ]; then
610	network_pass4
611fi
612
613# Raise kernel security level.  This should be done only after `fsck' has
614# repaired local file systems if you want the securelevel to be greater than 1.
615#
616case ${kern_securelevel_enable} in
617[Yy][Ee][Ss])
618	if [ "${kern_securelevel}" -ge 0 ]; then
619		echo 'Raising kernel security level'
620		sysctl -w kern.securelevel=${kern_securelevel}
621	fi
622	;;
623esac
624
625date
626exit 0
627